# Service_Amazon_S3

Extends \Service_Amazon

Abstract Service_Amazon_S3 class.

Provides common methods and properties to all of the S3 tasks

version | $ID$
package | phing.tasks.ext
author | Andrei Serdeliuc andrei@serdeliuc.ro

### Methods

## Property getter

    __get(mixed $var) : mixed

inherited

If the property hasn't been previously set (through the task call normally), it will try to load it from the project

This way, we can define global properties for the "Amazon" service, like key and secret

### Arguments

#### $var

`mixed`

### Response

`mixed`

## __isset

    __isset( $var) : boolean

inherited

### Arguments

#### $var

``

### Response

`boolean`

## __set

    __set( $var,  $val)

inherited

### Arguments

#### $var

``

#### $val

``

## Create a bucket

    createBucket() : boolean

### Response

`boolean`

## Entry point to children tasks

    execute() : void

abstract

## getBucket

    getBucket()

throws |

## Returns an instance of Services_Amazon_S3_Resource_Bucket

    getBucketInstance() : \Services_Amazon_S3_Resource_Bucket

### Response

`\Services_Amazon_S3_Resource_Bucket`

## We only instantiate the client once per task call

    getClient() : \Services_Amazon_S3

### Response

`\Services_Amazon_S3`

## Returns the textual description of the task

    getDescription() : string

inherited

### Response

`string`

The text description of the task

## getKey

    getKey()

inherited

## Returns the location within the buildfile this task occurs. Used by {@link BuildException} to give detailed error messages.

    getLocation() : \Location

inherited

### Response

`\Location`

The location object describing the position of this task within the buildfile.

## Get the contents of an object (by it's name)

    getObjectContents(string $object) : mixed

throws |

### Arguments

#### $object

`string`

### Response

`mixed`

## Returns an instance of Services_Amazon_S3_Resource_Object

    getObjectInstance(mixed $object) : \Services_Amazon_S3_Resource_Object

### Arguments

#### $object

`mixed`

### Response

`\Services_Amazon_S3_Resource_Object`

## Returns the owning target of this task.

    getOwningTarget() : \Target

inherited

### Response

`\Target`

The target object that owns this task

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Returns a name

    getRegisterSlot(string $slotName) : \RegisterSlot

inherited

### Arguments

#### $slotName

`string`

### Response

`\RegisterSlot`

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

inherited

### Response

`\RuntimeConfigurable`

The wrapper object used by this task

## getSecret

    getSecret()

inherited

## Returns the name of task, used only for log messages

    getTaskName() : string

inherited

### Response

`string`

Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

inherited

### Response

`string`

The type of this task (XML Tag)

## Called by the parser to let the task initialize properly.

    init()

inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

throws |

## Check if the current bucket is available

    isBucketAvailable() : boolean

### Response

`boolean`

## Check if the object already exists in the current bucket

    isObjectAvailable(mixed $object) : boolean

### Arguments

#### $object

`mixed`

### Response

`boolean`

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Called by the project to let the task do it's work. This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running <em>phing target1 target2</em> will run all tasks in target3 twice.

    main()

inherited abstract

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

## Configure this task if it hasn't been done already.

    maybeConfigure()

inherited

## Perfrom this task

    perform()

inherited

throws |

## setBucket

    setBucket( $bucket)

throws |

### Arguments

#### $bucket

``

## Sets a textual description of the task

    setDescription(string $desc)

inherited

### Arguments

#### $desc

`string`

The text describing the task

## setKey

    setKey( $key)

inherited

throws |

### Arguments

#### $key

``

## Sets the location within the buildfile this task occurs. Called by the parser to set location information.

    setLocation(\Location $location)

inherited

### Arguments

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

inherited

### Arguments

#### $target

`\Target`

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

inherited

### Arguments

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## setSecret

    setSecret( $secret)

inherited

throws |

### Arguments

#### $secret

``

## Sets the name of this task for log messages

    setTaskName(string $name) : string

inherited

### Arguments

#### $name

`string`

### Response

`string`

A string representing the name of this task for log

## Sets the type of the task. Usually this is the name of the XML tag

    setTaskType( $name)

inherited

### Arguments

#### $name

``

### Properties

## Services_Amazon_S3 client

    _client : \Services_Amazon_S3

(default value: null)

var |
see |

### Type(s)

`\Services_Amazon_S3`

## Collection of set options

    _options : array

inherited

We set these magically so we can also load then from the environment

(default value: array())

var |

### Type(s)

`array`

## Owning Target object

    target : \Target

inherited

var |

### Type(s)

`\Target`

## Description of the task

    description : string

inherited

var |

### Type(s)

`string`

## Internal taskname (req)

    taskType : string

inherited

var |

### Type(s)

`string`

## Taskname for logger

    taskName : string

inherited

var |

### Type(s)

`string`

## Stored buildfile location

    location : \Location

inherited

var |

### Type(s)

`\Location`

## Wrapper of the task

    wrapper : \RuntimeConfigurable

inherited

var |

### Type(s)

`\RuntimeConfigurable`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`